package org.jboss.hal.client.configuration.subsystem.distributableweb;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;
import javax.inject.Inject;

import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import elemental2.dom.HTMLElement;
import org.jboss.gwt.elemento.core.builder.ElementsBuilder;
import org.jboss.gwt.elemento.core.Elements;
import org.jboss.gwt.elemento.template.TemplateUtil;
import org.jboss.hal.ballroom.form.Form;
import org.jboss.hal.ballroom.table.Scope;
import org.jboss.hal.ballroom.LayoutBuilder;
import org.jboss.hal.ballroom.autocomplete.ReadChildrenAutoComplete;
import org.jboss.hal.ballroom.VerticalNavigation;
import org.jboss.hal.core.mbui.dialog.AddResourceDialog;
import org.jboss.hal.core.mbui.form.GroupedForm;
import org.jboss.hal.core.mbui.form.ModelNodeForm;
import org.jboss.hal.core.mbui.table.ModelNodeTable;
import org.jboss.hal.core.mbui.MbuiContext;
import org.jboss.hal.dmr.Operation;
import org.jboss.hal.dmr.ResourceAddress;
import org.jboss.hal.meta.AddressTemplate;
import org.jboss.hal.meta.Metadata;
import org.jboss.hal.meta.security.Constraint;
import org.jboss.hal.resources.Ids;
import org.jboss.hal.spi.Message;
import org.jboss.hal.spi.MessageEvent;

import static java.util.Arrays.asList;
import static org.jboss.gwt.elemento.core.Elements.*;
import static org.jboss.hal.ballroom.LayoutBuilder.column;
import static org.jboss.hal.ballroom.LayoutBuilder.row;
import static org.jboss.hal.dmr.ModelDescriptionConstants.ADD;
import static org.jboss.hal.dmr.ModelDescriptionConstants.READ_RESOURCE_OPERATION;

/*
 * WARNING! This class is generated. Do not modify.
 */
@Generated("org.jboss.hal.processor.mbui.MbuiViewProcessor")
public final class Mbui_DistributableWebView extends DistributableWebView {

    private final Metadata metadata0;
    private final Metadata metadata3;
    private final Metadata metadata1;
    private final Metadata metadata2;
    private final Metadata metadata4;
    private final Map<String, HTMLElement> expressionElements;

    @Inject
    @SuppressWarnings("unchecked")
    public Mbui_DistributableWebView(MbuiContext mbuiContext) {
        super(mbuiContext);

        AddressTemplate metadata0Template = AddressTemplate.of("/{selected.profile}/subsystem=distributable-web");
        this.metadata0 = mbuiContext.metadataRegistry().lookup(metadata0Template);
        AddressTemplate metadata3Template = AddressTemplate.of("/{selected.profile}/subsystem=distributable-web/infinispan-session-management=*");
        this.metadata3 = mbuiContext.metadataRegistry().lookup(metadata3Template);
        AddressTemplate metadata1Template = AddressTemplate.of("/{selected.profile}/subsystem=distributable-web/hotrod-session-management=*");
        this.metadata1 = mbuiContext.metadataRegistry().lookup(metadata1Template);
        AddressTemplate metadata2Template = AddressTemplate.of("/{selected.profile}/subsystem=distributable-web/hotrod-single-sign-on-management=*");
        this.metadata2 = mbuiContext.metadataRegistry().lookup(metadata2Template);
        AddressTemplate metadata4Template = AddressTemplate.of("/{selected.profile}/subsystem=distributable-web/infinispan-single-sign-on-management=*");
        this.metadata4 = mbuiContext.metadataRegistry().lookup(metadata4Template);
        this.expressionElements = new HashMap<>();

        configurationForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.ModelNode>("dw-configuration-form", metadata0)
            .onSave((form, changedValues) -> saveSingletonForm("Distributable Web", metadata0Template.resolve(statementContext()), changedValues, metadata0))
            .prepareReset(form -> resetSingletonForm("Distributable Web", metadata0Template.resolve(statementContext()), form, metadata0))
            .build();
        hotRodSessionManagementForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("dw-hotrod-session-management-form", metadata1)
            .onSave((form, changedValues) -> {
                String name = form.getModel().getName();
                saveForm("Hotrod Session Management", name, metadata1Template.resolve(statementContext(), name), changedValues, metadata1);
            })
            .prepareReset(form -> {
                String name = form.getModel().getName();
                resetForm("Hotrod Session Management", name, metadata1Template.resolve(statementContext(), name), form, metadata1);
            })
            .build();
        hotRodSSOManagementForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("dw-hotrod-sso-management-form", metadata2)
            .onSave((form, changedValues) -> {
                String name = form.getModel().getName();
                saveForm("Hotrod Single Sign On Management", name, metadata2Template.resolve(statementContext(), name), changedValues, metadata2);
            })
            .prepareReset(form -> {
                String name = form.getModel().getName();
                resetForm("Hotrod Single Sign On Management", name, metadata2Template.resolve(statementContext(), name), form, metadata2);
            })
            .build();
        infinispanSessionManagementForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("dw-infinispan-session-management-form", metadata3)
            .onSave((form, changedValues) -> {
                String name = form.getModel().getName();
                saveForm("Infinispan Session Management", name, metadata3Template.resolve(statementContext(), name), changedValues, metadata3);
            })
            .prepareReset(form -> {
                String name = form.getModel().getName();
                resetForm("Infinispan Session Management", name, metadata3Template.resolve(statementContext(), name), form, metadata3);
            })
            .build();
        infinispanSSOManagementForm = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("dw-infinispan-sso-management-form", metadata4)
            .onSave((form, changedValues) -> {
                String name = form.getModel().getName();
                saveForm("Infinispan Single Sign On Management", name, metadata4Template.resolve(statementContext(), name), changedValues, metadata4);
            })
            .prepareReset(form -> {
                String name = form.getModel().getName();
                resetForm("Infinispan Single Sign On Management", name, metadata4Template.resolve(statementContext(), name), form, metadata4);
            })
            .build();

        hotRodSessionManagementTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("dw-hotrod-session-management-table", metadata1)
            .button(mbuiContext.tableButtonFactory().add(Ids.build("dw-hotrod-session-management-table", Ids.ADD), "Hotrod Session Management",
                metadata1Template,
                (name, address) -> presenter.reload()))
            .button(mbuiContext.tableButtonFactory().remove("Hotrod Session Management", metadata1Template,
                table -> table.selectedRow().getName(),
                () -> presenter.reload()))
            .column("name", (cell, type, row, meta) -> row.getName())
            .build();
        hotRodSSOManagementTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("dw-hotrod-sso-management-table", metadata2)
            .button(mbuiContext.tableButtonFactory().add(Ids.build("dw-hotrod-sso-management-table", Ids.ADD), "Hotrod Single Sign On Management",
                metadata2Template,
                (name, address) -> presenter.reload()))
            .button(mbuiContext.tableButtonFactory().remove("Hotrod Single Sign On Management", metadata2Template,
                table -> table.selectedRow().getName(),
                () -> presenter.reload()))
            .column("name", (cell, type, row, meta) -> row.getName())
            .build();
        infinispanSessionManagementTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("dw-infinispan-session-management-table", metadata3)
            .button(mbuiContext.tableButtonFactory().add(Ids.build("dw-infinispan-session-management-table", Ids.ADD), "Infinispan Session Management",
                metadata3Template,
                (name, address) -> presenter.reload()))
            .button(mbuiContext.tableButtonFactory().remove("Infinispan Session Management", metadata3Template,
                table -> table.selectedRow().getName(),
                () -> presenter.reload()))
            .column("name", (cell, type, row, meta) -> row.getName())
            .build();
        infinispanSSOManagementTable = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("dw-infinispan-sso-management-table", metadata4)
            .button(mbuiContext.tableButtonFactory().add(Ids.build("dw-infinispan-sso-management-table", Ids.ADD), "Infinispan Single Sign On Management",
                metadata4Template,
                (name, address) -> presenter.reload()))
            .button(mbuiContext.tableButtonFactory().remove("Infinispan Single Sign On Management", metadata4Template,
                table -> table.selectedRow().getName(),
                () -> presenter.reload()))
            .column("name", (cell, type, row, meta) -> row.getName())
            .build();

        navigation = new VerticalNavigation();
        HTMLElement html0;
        HTMLElement dwConfigurationItemElement = section()
            .add(html0 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Distributable Web</h1><p>${metadata0.getDescription().getDescription()}</p>"))
                            .get())
            .add(configurationForm)
                    .get();
        expressionElements.put("html0", html0);
        navigation.addPrimary("dw-configuration-item", "Configuration", "pficon pficon-settings", dwConfigurationItemElement);
        HTMLElement html2;
        HTMLElement dwHotrodSessionManagementItemElement = section()
            .add(html2 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>HotRod Session Management</h1><p>${metadata1.getDescription().getDescription()}</p>"))
                            .get())
            .add(hotRodSessionManagementTable)
            .add(hotRodSessionManagementForm)
                    .get();
        expressionElements.put("html2", html2);
        navigation.addPrimary("dw-hotrod-session-management-item", "HotRod Session", "pficon pficon-users", dwHotrodSessionManagementItemElement);
        HTMLElement html5;
        HTMLElement dwHotrodSsoManagementItemElement = section()
            .add(html5 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>HotRod SSO Management</h1><p>${metadata2.getDescription().getDescription()}</p>"))
                            .get())
            .add(hotRodSSOManagementTable)
            .add(hotRodSSOManagementForm)
                    .get();
        expressionElements.put("html5", html5);
        navigation.addPrimary("dw-hotrod-sso-management-item", "HotRod SSO", "fa fa-lock", dwHotrodSsoManagementItemElement);
        HTMLElement html8;
        HTMLElement dwInfinispanSessionManagementItemElement = section()
            .add(html8 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Infinispan Session Management</h1><p>${metadata3.getDescription().getDescription()}</p>"))
                            .get())
            .add(infinispanSessionManagementTable)
            .add(infinispanSessionManagementForm)
                    .get();
        expressionElements.put("html8", html8);
        navigation.addPrimary("dw-infinispan-session-management-item", "Infinispan Session", "pficon pficon-users", dwInfinispanSessionManagementItemElement);
        HTMLElement html11;
        HTMLElement dwInfinispanSsoManagementItemElement = section()
            .add(html11 = div()
                .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Infinispan SSO Management</h1><p>${metadata4.getDescription().getDescription()}</p>"))
                            .get())
            .add(infinispanSSOManagementTable)
            .add(infinispanSSOManagementForm)
                    .get();
        expressionElements.put("html11", html11);
        navigation.addPrimary("dw-infinispan-sso-management-item", "Infinispan SSO", "fa fa-lock", dwInfinispanSsoManagementItemElement);
        HTMLElement root = row()
            .add(column()
                .addAll(navigation.panes()))
            .get();

        registerAttachable(navigation);
        registerAttachable(configurationForm);
        registerAttachable(hotRodSessionManagementTable);
        registerAttachable(hotRodSessionManagementForm);
        registerAttachable(hotRodSSOManagementTable);
        registerAttachable(hotRodSSOManagementForm);
        registerAttachable(infinispanSessionManagementTable);
        registerAttachable(infinispanSessionManagementForm);
        registerAttachable(infinispanSSOManagementTable);
        registerAttachable(infinispanSSOManagementForm);

        initElement(root);

        init();
    }

    @Override
    public void attach() {
        super.attach();

            hotRodSessionManagementTable.bindForm(hotRodSessionManagementForm);
            hotRodSSOManagementTable.bindForm(hotRodSSOManagementForm);
            infinispanSessionManagementTable.bindForm(infinispanSessionManagementForm);
            infinispanSSOManagementTable.bindForm(infinispanSSOManagementForm);

        TemplateUtil.replaceExpression(expressionElements.get("html0"), "${metadata0.getDescription().getDescription()}", String.valueOf(metadata0.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html2"), "${metadata1.getDescription().getDescription()}", String.valueOf(metadata1.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html5"), "${metadata2.getDescription().getDescription()}", String.valueOf(metadata2.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html8"), "${metadata3.getDescription().getDescription()}", String.valueOf(metadata3.getDescription().getDescription()));
        TemplateUtil.replaceExpression(expressionElements.get("html11"), "${metadata4.getDescription().getDescription()}", String.valueOf(metadata4.getDescription().getDescription()));
    }
}
