package org.jboss.hal.client.configuration.subsystem.undertow;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;
import javax.inject.Inject;

import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import elemental2.dom.HTMLElement;
import org.jboss.gwt.elemento.core.builder.ElementsBuilder;
import org.jboss.gwt.elemento.core.Elements;
import org.jboss.gwt.elemento.template.TemplateUtil;
import org.jboss.hal.ballroom.form.Form;
import org.jboss.hal.ballroom.table.Scope;
import org.jboss.hal.ballroom.LayoutBuilder;
import org.jboss.hal.ballroom.autocomplete.ReadChildrenAutoComplete;
import org.jboss.hal.core.mbui.dialog.AddResourceDialog;
import org.jboss.hal.core.mbui.form.GroupedForm;
import org.jboss.hal.core.mbui.form.ModelNodeForm;
import org.jboss.hal.core.mbui.table.ModelNodeTable;
import org.jboss.hal.core.mbui.MbuiContext;
import org.jboss.hal.dmr.Operation;
import org.jboss.hal.dmr.ResourceAddress;
import org.jboss.hal.meta.AddressTemplate;
import org.jboss.hal.meta.Metadata;
import org.jboss.hal.meta.security.Constraint;
import org.jboss.hal.resources.Ids;
import org.jboss.hal.spi.Message;
import org.jboss.hal.spi.MessageEvent;

import static java.util.Arrays.asList;
import static org.jboss.gwt.elemento.core.Elements.*;
import static org.jboss.hal.ballroom.LayoutBuilder.column;
import static org.jboss.hal.ballroom.LayoutBuilder.row;
import static org.jboss.hal.dmr.ModelDescriptionConstants.ADD;
import static org.jboss.hal.dmr.ModelDescriptionConstants.READ_RESOURCE_OPERATION;

/*
 * WARNING! This class is generated. Do not modify.
 */
@Generated("org.jboss.hal.processor.mbui.MbuiViewProcessor")
public final class Mbui_BufferCacheView extends BufferCacheView {

    private final Metadata metadata92;
    private final Map<String, HTMLElement> expressionElements;

    @Inject
    @SuppressWarnings("unchecked")
    public Mbui_BufferCacheView(MbuiContext mbuiContext) {
        super(mbuiContext);

        AddressTemplate metadata92Template = AddressTemplate.of("/{selected.profile}/subsystem=undertow/buffer-cache=*");
        this.metadata92 = mbuiContext.metadataRegistry().lookup(metadata92Template);
        this.expressionElements = new HashMap<>();

        form = new ModelNodeForm.Builder<org.jboss.hal.dmr.NamedNode>("buffer-cache-form", metadata92)
            .onSave((form, changedValues) -> {
                String name = form.getModel().getName();
                saveForm("Buffer Cache", name, metadata92Template.resolve(statementContext(), name), changedValues, metadata92);
            })
            .prepareReset(form -> {
                String name = form.getModel().getName();
                resetForm("Buffer Cache", name, metadata92Template.resolve(statementContext(), name), form, metadata92);
            })
            .build();

        table = new ModelNodeTable.Builder<org.jboss.hal.dmr.NamedNode>("buffer-cache-table", metadata92)
            .button(mbuiContext.tableButtonFactory().add(Ids.build("buffer-cache-table", Ids.ADD), "Buffer Cache",
                metadata92Template,
                (name, address) -> presenter.reload()))
            .button(mbuiContext.tableButtonFactory().remove("Buffer Cache", metadata92Template,
                table -> table.selectedRow().getName(),
                () -> presenter.reload()))
            .column("name", (cell, type, row, meta) -> row.getName())
            .build();

        HTMLElement html267;
        HTMLElement root = row()
            .add(column()
                .add(html267 = div()
                    .innerHtml(SafeHtmlUtils.fromSafeConstant("<h1>Buffer Cache</h1><p>${metadata92.getDescription().getDescription()}</p>"))
                        .get())
                                .add(table)
                                .add(form)
                )
                .get();
        expressionElements.put("html267", html267);

        registerAttachable(table);
        registerAttachable(form);

        initElement(root);

    }

    @Override
    public void attach() {
        super.attach();

            table.bindForm(form);

        TemplateUtil.replaceExpression(expressionElements.get("html267"), "${metadata92.getDescription().getDescription()}", String.valueOf(metadata92.getDescription().getDescription()));
    }
}
